#! /bin/sh

# Adding the '-w' flag shortens the .d files by allowing
# more dependencies on one line. It may even speed up rmkdepend
# (picking 1000 because larger seems to break sed on some systems)

trap "rm -f $1.tmp $1.tmp.bak; exit 1" 1 2 3 15

touch $1.tmp

bin/rmkdepend -f$1.tmp -Y -w 1000 -- $2 -- $3 > /dev/null 2>&1
depstat=$?
if [ $depstat -ne 0 ]; then
   rm -f $1.tmp $1.tmp.bak
   exit $depstat
fi

# adding .d file as target
isdict=`expr $3 : '.*/G__.*\.cxx'`
if test $isdict -ne 0 ; then
   sed -e 's@^\(.*\)\.o[ :]*\(.*\)@\1.d: $\(wildcard \2\)\@\1.cxx: $\(wildcard \2\)@' -e 's@^#.*$@@' -e '/^$/d' $1.tmp | tr '@' '\n'
else
   sed -e 's@^\(.*\)\.o[ :]*\(.*\)@\1.d: $\(wildcard \2\)\@\1.o: \2@' -e 's@^#.*$@@' -e '/^$/d' $1.tmp | tr '@' '\n'
fi
rm -f $1.tmp $1.tmp.bak

exit 0
